<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_GenericCatalogueItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_GenericCatalogueItem extends AbstractStructArrayBase
{
    /**
     * The CatalogueItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_GenericCatalogueItem[]
     */
    public $CatalogueItem;
    /**
     * Constructor method for ArrayOfJP_GenericCatalogueItem
     * @uses ArrayOfJP_GenericCatalogueItem::setCatalogueItem()
     * @param \StructType\JP_GenericCatalogueItem[] $catalogueItem
     */
    public function __construct(array $catalogueItem = array())
    {
        $this
            ->setCatalogueItem($catalogueItem);
    }
    /**
     * Get CatalogueItem value
     * @return \StructType\JP_GenericCatalogueItem[]|null
     */
    public function getCatalogueItem()
    {
        return $this->CatalogueItem;
    }
    /**
     * This method is responsible for validating the values passed to the setCatalogueItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCatalogueItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCatalogueItemForArrayConstraintsFromSetCatalogueItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_GenericCatalogueItemCatalogueItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_GenericCatalogueItemCatalogueItemItem instanceof \StructType\JP_GenericCatalogueItem) {
                $invalidValues[] = is_object($arrayOfJP_GenericCatalogueItemCatalogueItemItem) ? get_class($arrayOfJP_GenericCatalogueItemCatalogueItemItem) : sprintf('%s(%s)', gettype($arrayOfJP_GenericCatalogueItemCatalogueItemItem), var_export($arrayOfJP_GenericCatalogueItemCatalogueItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CatalogueItem property can only contain items of type \StructType\JP_GenericCatalogueItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CatalogueItem value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_GenericCatalogueItem[] $catalogueItem
     * @return \ArrayType\ArrayOfJP_GenericCatalogueItem
     */
    public function setCatalogueItem(array $catalogueItem = array())
    {
        // validation for constraint: array
        if ('' !== ($catalogueItemArrayErrorMessage = self::validateCatalogueItemForArrayConstraintsFromSetCatalogueItem($catalogueItem))) {
            throw new \InvalidArgumentException($catalogueItemArrayErrorMessage, __LINE__);
        }
        $this->CatalogueItem = $catalogueItem;
        return $this;
    }
    /**
     * Add item to CatalogueItem value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_GenericCatalogueItem $item
     * @return \ArrayType\ArrayOfJP_GenericCatalogueItem
     */
    public function addToCatalogueItem(\StructType\JP_GenericCatalogueItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_GenericCatalogueItem) {
            throw new \InvalidArgumentException(sprintf('The CatalogueItem property can only contain items of type \StructType\JP_GenericCatalogueItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CatalogueItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_GenericCatalogueItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_GenericCatalogueItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_GenericCatalogueItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_GenericCatalogueItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_GenericCatalogueItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CatalogueItem
     */
    public function getAttributeName()
    {
        return 'CatalogueItem';
    }
}
